package com.example.conversationsdk.activity;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ListView;

import com.example.conversationsdk.PreferenceUtils;
import com.example.conversationsdk.R;

public class CustomizeUISettingsActivity extends Activity {

    private ListView listView;

    /*
     public boolean binderEmailAddressEnabled = true;
     public boolean binderDuplicateEnabled = true;

        public boolean telephonyEnabled = true;
        public boolean voiceIPEnabled = true;
        public boolean videoEnabled = true;
        public boolean shareScreenEnabled = true;
        public boolean shareDocumentEnabled = true;
        public boolean meetRecordingEnabled = true;
        public boolean autoJoinVOIP = true;
        public boolean inviteParticipants = true;
        public boolean inviteForAttendee = true;
        public boolean inviteViaSMS = true;
        public boolean meetLinkEnabled = true;
        public boolean enableAnnotateOfPartcipants = true;
        public boolean hasParticipantsList = true;
        public boolean attendeeJoinMeetMuted = false;
        public boolean hasUnmuteForAttendee = true;
        public boolean hasVideoForAttendee = true;
        public boolean unMuteAttendeeForHostEnabled = false;
        public boolean unMuteAttendeeForPresenter = false;
     */

    private String[] ListItems = new String[]{
            "binderEmailAddressEnabled",
            "binderDuplicateEnabled",

            "telephonyEnabled",
            "voiceIPEnabled",
            "videoEnabled",
            "shareScreenEnabled",
            "shareDocumentEnabled",
            "meetRecordingEnabled",
            "autoJoinVOIP",
            "inviteParticipants",
            "inviteForAttendee",
            "inviteViaSMS",
            "meetLinkEnabled",
            "hideMeetLinkPanel",
            "enableAnnotateOfPartcipants",
            "hasParticipantsList",
            "attendeeJoinMeetMuted",
            "hasUnmuteForAttendee",
            "hasVideoForAttendee",
            "unMuteAttendeeForHostEnabled",
            "unMuteAttendeeForPresenter"
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_customize_uisettings);
        listView = (ListView)findViewById(R.id.list_view);
        listView.setAdapter(new SettingAdapter());
    }


    class SettingAdapter extends BaseAdapter{

        @Override
        public int getCount() {
            return ListItems.length;
        }

        @Override
        public Object getItem(int i) {
            return ListItems[i];
        }

        @Override
        public long getItemId(int i) {
            return 0;
        }

        @Override
        public View getView(final int i, View view, ViewGroup viewGroup) {
            CheckBox cb;
            if(view == null){
                    cb = new CheckBox(CustomizeUISettingsActivity.this);
                    cb.setChecked(PreferenceUtils.getInstance(CustomizeUISettingsActivity.this).getBoolean(ListItems[i], true));
                    AbsListView.LayoutParams llp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
                    cb.setLayoutParams(llp);
                    cb.setText(ListItems[i]);
            }else{
                cb = (CheckBox) view;
            }


            cb.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
                @Override
                public void onCheckedChanged(CompoundButton compoundButton, boolean b) {
                    PreferenceUtils.getInstance(CustomizeUISettingsActivity.this).saveBoolean(ListItems[i], b);
                }
            });

            return cb;
        }
    }
}
