package com.example.conversationsdk.activity;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.support.v4.app.FragmentActivity;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.example.conversationsdk.CustomizeUISettings;
import com.example.conversationsdk.R;
import com.example.conversationsdk.fragment.BinderListFragment;
import com.moxtra.binder.conversation.MXConversationActivity;
import com.moxtra.sdk.MXAccountManager;
import com.moxtra.sdk.MXChatCustomizer;
import com.moxtra.sdk.MXChatManager;
import com.moxtra.sdk.MXException;
import com.moxtra.sdk.MXException.AccountManagerIsNotValid;
import com.moxtra.sdk.MXGroupChatMember;
import com.moxtra.sdk.MXGroupMeetMember;
import com.moxtra.sdk.MXNotificationManager;
import com.moxtra.sdk.MXSDKConfig;
import com.moxtra.sdk.MXSDKException;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Phone_MainActivity extends FragmentActivity {
    private static final String TAG = "MainActivity";

    private static final int DIALOG_USER_PROFILE = 1;
    private static final int DIALOG_INVITE = 2;
    private static final int DIALOG_JOIN_MEET = 3;
    private static final int DIALOG_OPEN_CHAT = 4;
    private static final int DIALOG_OPEN_INDIVIDUAL_CHAT = 5;
    private static final int REQUEST_CREATE_GROUP_CHAT = 100;
    private static final int DIALOG_CLEAR_UNREAD_MSG = 6;
    private static final int DIALOG_DELETE_CHAT = 7;
    private static final int DIALOG_GET_CHAT_MEMBERS = 8;

    private View contentView;

    //public static String mBinderID;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        init();
        if(getIntent() != null)
            MXNotificationManager.processMXNotification(this, getIntent());

        Toast.makeText(this, MXChatManager.getInstance().getSDKVersion(), Toast.LENGTH_SHORT).show();

//        MXChatCustomizer.setUserActionExceededCallback(new UserActionExceededCallback(){
//
//            @Override
//            public void onMeetExpired(long l) {
//                Toast.makeText(Phone_MainActivity.this, "Meet will expired in " + l + " milliseconds...", Toast.LENGTH_LONG).show();
//            }
//
//            @Override
//            public void onMeetWillExpired(long l) {
//                Toast.makeText(Phone_MainActivity.this, "Meet will expired in " + l + " milliseconds...", Toast.LENGTH_LONG).show();
//            }
//
//            @Override
//            public void onNumberOfMeetMemberExceeded(long l) {
//                Toast.makeText(Phone_MainActivity.this, "onNumberOfMeetMemberExceeded " + l + "...", Toast.LENGTH_LONG).show();
//            }
//
//            @Override
//            public void onNumberOfChatMemberExceeded() {
//                Toast.makeText(Phone_MainActivity.this, "onNumberOfChatMemberExceeded", Toast.LENGTH_LONG).show();
//            }
//
//            @Override
//            public void onStorageExceeded() {
//                Toast.makeText(Phone_MainActivity.this, "onStorageExceeded", Toast.LENGTH_LONG).show();
//            }
//
//            @Override
//            public void onSizeOfFileExceeded(String s, long l) {
//                Toast.makeText(Phone_MainActivity.this, "onSizeOfFileExceeded " + l + " bytes...", Toast.LENGTH_LONG).show();
//            }
//
//            @Override
//            public void onChatHistoryExceeded(long l) {
//                Toast.makeText(Phone_MainActivity.this, "onChatHistoryExceeded " + l + " milliseconds...", Toast.LENGTH_LONG).show();
//            }
//        });
    }

    private void init() {
        MXChatCustomizer.setOpenChatEventListener(null);
        if (!LoginActivity.USE_GCM) {
            MXChatManager.getInstance().setRemoteNotificationType(MXChatManager.PushNotificationType.LONG_CONNECTION);
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        switch (requestCode) {
            case REQUEST_CREATE_GROUP_CHAT:
                if (resultCode == Activity.RESULT_OK) {
                    //mBinderID = data.getExtras().getString("binderID");
                }
                break;

            default:
                super.onActivityResult(requestCode, resultCode, data);
                break;
        }
    }

    protected Dialog createDialog(final int id) {
        switch (id) {
            case DIALOG_USER_PROFILE: {
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle(R.string.update_profile);
                LayoutInflater inflater = super.getLayoutInflater();
                contentView = inflater.inflate(R.layout.dialog_user_profile, null);
                builder.setView(contentView)
                        .setPositiveButton(R.string.Done, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int id) {
                                EditText etFirstName = (EditText) contentView.findViewById(R.id.et_firstname);
                                EditText etLastName = (EditText) contentView.findViewById(R.id.et_lastname);
                                File file = new File(Environment.getExternalStorageDirectory(), "/Download/001.png");
                                MXSDKConfig.MXProfileInfo profile = new MXSDKConfig.MXProfileInfo(etFirstName.getText().toString(), etLastName.getText().toString(), file.getAbsolutePath());
                                MXAccountManager.getInstance().updateUserProfile(profile);
                            }
                        })
                        .setNegativeButton(R.string.Cancel, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                            }
                        });
                return builder.create();
            }

            case DIALOG_INVITE: {
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle(R.string.invite_to_chat);
                LayoutInflater inflater = super.getLayoutInflater();
                contentView = inflater.inflate(R.layout.dialog_invite_to_chat, null);
                contentView.findViewById(R.id.et_binder_id).setVisibility(View.VISIBLE);
                builder.setView(contentView)
                        .setPositiveButton(R.string.Done, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int id) {
                                EditText etUniqueID = (EditText) contentView.findViewById(R.id.et_unique_id);
                                EditText etBinderID = (EditText) contentView.findViewById(R.id.et_binder_id);

                                List<String> uniqueIds = new ArrayList<String>();

                                if (!TextUtils.isEmpty(etUniqueID.getText().toString())) {
                                    String[] arrUniqueId = etUniqueID.getText().toString().split(";");
                                    uniqueIds.addAll(Arrays.asList(arrUniqueId));
                                }

//                                Map<String, List<String>> orgUniqueIdMap = new HashMap<String, List<String>>();
//                                orgUniqueIdMap.put("Pg3dAcMahyYFJDE4HyfFZw6", uniqueIds);
                                //MXChatManager.getInstance(). inviteByUniqueIdsWithOrgId(mBinderID, orgUniqueIdMap,
                                MXChatManager.getInstance().inviteByUniqueIds(etBinderID.getText().toString(), uniqueIds, new MXChatManager.OnInviteListener() {
                                    @Override
                                    public void onInviteSuccess() {
                                        Toast.makeText(Phone_MainActivity.this, "Invite success.", Toast.LENGTH_LONG).show();
                                    }

                                    @Override
                                    public void onInviteFailed(int errorCode, String message) {
                                        Log.e(TAG, "Invite failed: " + message);
                                        Toast.makeText(Phone_MainActivity.this, "Invite failed: " + message, Toast.LENGTH_LONG).show();
                                    }
                                });
                            }
                        })
                        .setNegativeButton(R.string.Cancel, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                            }
                        });
                return builder.create();
            }

            case DIALOG_OPEN_INDIVIDUAL_CHAT: {
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle(R.string.invite_to_chat);
                LayoutInflater inflater = super.getLayoutInflater();
                contentView = inflater.inflate(R.layout.dialog_invite_to_chat, null);
                builder.setView(contentView)
                        .setPositiveButton(R.string.Done, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int id) {
                                EditText etUniqueID = (EditText) contentView.findViewById(R.id.et_unique_id);
                                try {
                                    MXChatManager.getInstance().createIndividualChat(etUniqueID.getText().toString(), new MXChatManager.OnCreateChatListener() {
                                        @Override
                                        public void onCreateChatSuccess(String s) {
                                            Log.i(TAG, "Create one on one chat success with id: " + s);
                                        }

                                        @Override
                                        public void onCreateChatFailed(int i, String s) {
                                            Toast.makeText(Phone_MainActivity.this, "Can't create chat: " + s, Toast.LENGTH_LONG).show();
                                            Log.e(TAG, "Create one on one chat failed with error msg: " + s);
                                        }
                                    });
                                } catch (AccountManagerIsNotValid accountManagerIsNotValid) {
                                    accountManagerIsNotValid.printStackTrace();
                                }
                            }
                        })
                        .setNegativeButton(R.string.Cancel, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                            }
                        });
                return builder.create();
            }

            case DIALOG_JOIN_MEET: {
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle(R.string.join_a_meet);
                LayoutInflater inflater = super.getLayoutInflater();
                contentView = inflater.inflate(R.layout.dialog_invite_to_chat, null);
                final EditText et = (EditText) contentView.findViewById(R.id.et_unique_id);
                et.setHint("Input Meet ID");
                builder.setView(contentView)
                        .setPositiveButton(R.string.Done, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int id) {
                                String meetId = et.getText().toString();
                                if (meetId.length() > 0)
                                    try {
                                        MXChatManager.getInstance().joinMeet(meetId, "WhoAmI", new MXChatManager.OnJoinMeetListener() {

                                            @Override
                                            public void onJoinMeetDone(String meetId, String meetUrl) {
                                                Toast.makeText(getApplicationContext(), "Join Meet Done, Meet Id:" + meetId + "/MeetUrl:" + meetUrl, Toast.LENGTH_LONG).show();
                                            }

                                            @Override
                                            public void onJoinMeetFailed() {
                                                Toast.makeText(getApplicationContext(), "Join Meet failed ...", Toast.LENGTH_LONG).show();
                                            }
                                        });
                                    } catch (MXSDKException.MeetIsInProgress e) {

                                    }
                                else
                                    Toast.makeText(getApplicationContext(), "Input Meet Id...", Toast.LENGTH_LONG).show();
                            }
                        })
                        .setNegativeButton(R.string.Cancel, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                            }
                        });
                return builder.create();
            }

            case DIALOG_OPEN_CHAT: {
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle(R.string.open_chat);
                LayoutInflater inflater = super.getLayoutInflater();
                contentView = inflater.inflate(R.layout.dialog_invite_to_chat, null);
                final EditText et = (EditText) contentView.findViewById(R.id.et_unique_id);
                et.setHint("Input Chat/Binder ID");
                builder.setView(contentView)
                        .setPositiveButton(R.string.Done, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int id) {
                                String binderId = et.getText().toString();
                                if (binderId.length() > 0)
                                    openChatWithBinderId(binderId);
                                else
                                    Toast.makeText(getApplicationContext(), "Input Chat/Binder ID...", Toast.LENGTH_LONG).show();
                            }
                        })
                        .setNegativeButton(R.string.Cancel, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                            }
                        });
                return builder.create();
            }

            case DIALOG_DELETE_CHAT:
            case DIALOG_CLEAR_UNREAD_MSG:
            case DIALOG_GET_CHAT_MEMBERS:{
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                if(id == DIALOG_DELETE_CHAT)
                    builder.setTitle("Delete Chat");
                else if(id == DIALOG_GET_CHAT_MEMBERS)
                    builder.setTitle("Get Binder Members");
                else if(id == DIALOG_CLEAR_UNREAD_MSG)
                    builder.setTitle(R.string.clear_unread_msg);
                LayoutInflater inflater = super.getLayoutInflater();
                contentView = inflater.inflate(R.layout.dialog_invite_to_chat, null);
                final EditText et = (EditText) contentView.findViewById(R.id.et_unique_id);
                et.setHint("Input Chat/Binder ID");
                builder.setView(contentView)
                        .setPositiveButton(R.string.Done, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int ids) {
                                String binderId = et.getText().toString();
                                if (!TextUtils.isEmpty(binderId)){
                                    if(id == DIALOG_DELETE_CHAT) {
                                        MXChatManager.getInstance().deleteChat(binderId);
                                    }
                                    else if(id == DIALOG_GET_CHAT_MEMBERS) {
                                        getAllMembersInBinder(binderId);
                                    }else if(id == DIALOG_CLEAR_UNREAD_MSG){
                                        MXChatManager.getInstance().markAsRead(binderId);
                                    }
                                }
                                else
                                    Toast.makeText(getApplicationContext(), "Input Chat/Binder ID...", Toast.LENGTH_LONG).show();
                            }
                        })
                        .setNegativeButton(R.string.Cancel, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                            }
                        });
                return builder.create();
            }
        }
        return null;
    }

    private void showCreatedDialog(int id){
        Dialog dialog = createDialog(id);
        if(dialog != null){
            dialog.show();
        }
    }

    public void markAsRead(View v){
        showCreatedDialog(DIALOG_CLEAR_UNREAD_MSG);
    }

    public void startMeetButtonPressed(View v) {
        try {
            CustomizeUISettings.setUISettings(this);
            MXChatManager.getInstance().startMeet("No Topic...", null, null, new MXChatManager.OnStartMeetListener() {

                @Override
                public void onStartMeetDone(String meetId, String meetUrl) {
                    Toast.makeText(getApplicationContext(), "Start Meet Done, Meet Id:" + meetId + "/MeetUrl:" + meetUrl, Toast.LENGTH_LONG).show();
                }

                @Override
                public void onStartMeetFailed(int errCode, String errMsg) {
                    Toast.makeText(getApplicationContext(), "Start Meet failed, ErrorCode:" + errCode + "/ErrorMessage:" + errMsg, Toast.LENGTH_LONG).show();
                }
            });
        } catch (MXSDKException.Unauthorized unauthorized) {
            unauthorized.printStackTrace();
        } catch (MXSDKException.MeetIsInProgress meetIsInProgress) {
            meetIsInProgress.printStackTrace();
        }
    }

    public void joinMeetButtonPressed(View v) {
        CustomizeUISettings.setUISettings(this);
        showCreatedDialog(DIALOG_JOIN_MEET);
    }

    public void inviteByUniqueButtonPressed(View v) {
        showCreatedDialog(DIALOG_INVITE);
    }

    public void setupButtonPressed(View v) {
        showCreatedDialog(DIALOG_USER_PROFILE);
    }

    public void createChatButtonPressed(View v) {
//        if (TextUtils.isEmpty(mBinderID)) {
            Intent i = new Intent(this, InviteToGroupChatActivity.class);
            super.startActivityForResult(i, REQUEST_CREATE_GROUP_CHAT);
//        } else {
//            try {
//                MXChatManager.getInstance().openChat(mBinderID, null);
//            } catch (AccountManagerIsNotValid e) {
//                e.printStackTrace();
//            }
//        }
    }

    public void createIndividualButtonPressed(View v) {
        showCreatedDialog(DIALOG_OPEN_INDIVIDUAL_CHAT);
    }

    public void deleteChatButtonPressed(View v) {
        showCreatedDialog(DIALOG_DELETE_CHAT);
    }

    public void unlinkButtonPressed(View v) {
        MXAccountManager mAccountMgr = null;
        mAccountMgr = MXAccountManager.getInstance();

        if (mAccountMgr == null)
            return;

        if (mAccountMgr != null && mAccountMgr.isLinked()){

            mAccountMgr.unlinkAccount(new MXAccountManager.MXAccountUnlinkListener() {
                @Override
                public void onUnlinkAccountDone(MXSDKConfig.MXUserInfo user) {
                    Toast.makeText(getApplicationContext(), getString(R.string.unlink_success), Toast.LENGTH_LONG).show();
                    MXChatManager.getInstance().unlink();
                    // jump to login activity
                    Intent intent = new Intent(Phone_MainActivity.this, LoginActivity.class);
                    Phone_MainActivity.this.startActivity(intent);
                    Phone_MainActivity.this.finish();
                }
            });
        }
    }

    public void setupAccountManagerButtonPressed(View v) {
        init();
    }

    public void openChatButtonClicked(View v) {
        showCreatedDialog(DIALOG_OPEN_CHAT);
    }

    private void openChatWithBinderId(final String binderId) {
        try {
            MXChatManager.getInstance().openChat(binderId, new MXChatManager.OnOpenChatListener() {

                @Override
                public void onOpenChatSuccess() {
                    Toast.makeText(Phone_MainActivity.this, "open binder successfully!", Toast.LENGTH_SHORT).show();
                }

                @Override
                public void onOpenChatFailed(int resultCode, String resultStr) {
                    switch (resultCode) {
                        case MXConversationActivity.OpenChatResultCallback.BINDER_ID_NOT_FOUND:
                            Toast.makeText(Phone_MainActivity.this, resultStr, Toast.LENGTH_SHORT).show();
                            break;
                        case MXConversationActivity.OpenChatResultCallback.BINDER_ID_NULL:
                            Toast.makeText(Phone_MainActivity.this, resultStr, Toast.LENGTH_SHORT).show();
                            break;
                        case MXConversationActivity.OpenChatResultCallback.USER_NOT_LOGIN:
                            Toast.makeText(Phone_MainActivity.this, resultStr, Toast.LENGTH_SHORT).show();
                            break;
                        case MXConversationActivity.OpenChatResultCallback.USER_OFFLINE:
                            Toast.makeText(Phone_MainActivity.this, resultStr, Toast.LENGTH_SHORT).show();
                            break;
                        default:
                            if (resultStr != null)
                                Toast.makeText(Phone_MainActivity.this, resultStr, Toast.LENGTH_SHORT).show();
                            break;
                    }
                }
            });
        } catch (AccountManagerIsNotValid e) {
            e.printStackTrace();
        }
    }

    private void getAllMembersInBinder(String binderID){
        MXChatManager.getInstance().getChatMembers(binderID, new MXChatManager.OnGetChatMembersListener() {
            @Override
            public void onGetChatMembersDone(ArrayList<MXGroupChatMember> users) {

                String allUsers;
                if(users.size() > 1) {
                    StringBuffer sb = new StringBuffer();
                    for(MXGroupChatMember user:users){
                        sb.append(user.getUniqueId()+"-" + user.getAvatarPath() + "/");
                    }
                    allUsers = sb.toString();
                }
                else if(users.size() == 1)
                    allUsers = users.get(0).getUniqueId() + "/" + users.get(0).getAvatarPath();
                else
                    allUsers = "No Users in Binder!";

                showUsers(allUsers);
            }

            @Override
            public void onGetChatMembersFailed(int code, String msg) {
            }
        });
    }

    public void getAllMembersInBinder(View v) {
        showCreatedDialog(DIALOG_GET_CHAT_MEMBERS);
    }

    public void getMeetMembers(View v){
        MXChatManager.getInstance().getMeetMembers(new MXChatManager.OnGetMeetMembersListener(){

            @Override
            public void onGetMeetMembersDone(ArrayList<MXGroupMeetMember> members) {
                String allUsers = "";
                for(MXGroupMeetMember member:members){
                    allUsers += member.getUniqueId() + "(" + member.getStatus().name() + ")/";
                }

                showUsers(allUsers);
            }

            @Override
            public void onGetMeetMembersFailed(int i, String s) {

            }
        });
    }

    public void getAllChatSessions(View v) {
        Intent intent = new Intent(this, BinderListFragmentActvitiy.class);
        intent.putExtra(BinderListFragment.GET_BINDERS_TYPE, BinderListFragment.ALL_CHAT_BINDERS);
        startActivity(intent);
    }

    public void inviteToMeet(View v){
//        List<String> uniqueIds = new ArrayList<String>();
//        Map<String, List<String>> orgUniqueIdMap = new HashMap<String, List<String>>();
//        uniqueIds.add("kindle");
//        orgUniqueIdMap.put("Pg3dAcMahyYFJDE4HyfFZw6", uniqueIds);
//        MXChatManager.getInstance().inviteParticipants(orgUniqueIdMap, "invite 2 meet!");
    }

    public void chatSettings(View v){
        Intent intent = new Intent(this, ChatManagerSettingsActivity.class);
        startActivity(intent);
    }

    public void uiSettings(View v){
        Intent intent = new Intent(this, CustomizeUISettingsActivity.class);
        startActivity(intent);
    }

    public static void openChat(final String binderId) {
        try {
            if (TextUtils.isEmpty(binderId))
                return;
            MXChatManager.getInstance().openChat(binderId, new MXChatManager.OnOpenChatListener() {
                @Override
                public void onOpenChatSuccess() {

                }

                @Override
                public void onOpenChatFailed(int i, String s) {

                }
            });
        } catch (MXException.AccountManagerIsNotValid accountManagerIsNotValid1) {
            accountManagerIsNotValid1.printStackTrace();
        }
    }

    public static void joinMeet(String meetId) {
        try {
            if (TextUtils.isEmpty(meetId))
                return;

            MXChatManager.getInstance().joinMeet(meetId, "user", new MXChatManager.OnJoinMeetListener() {
                @Override
                public void onJoinMeetDone(String s, String s2) {

                }

                @Override
                public void onJoinMeetFailed() {

                }
            });
        } catch (MXSDKException.MeetIsInProgress meetIsInProgress) {
            meetIsInProgress.printStackTrace();
        }
    }

    @Override
    public void onNewIntent(Intent intent){
        super.onNewIntent(intent);
        Log.d(TAG, "onNewIntent");
        MXNotificationManager.processMXNotification(this,intent);
    }

    private void showUsers(String users){
        AlertDialog.Builder builder = new AlertDialog.Builder(Phone_MainActivity.this);
        builder.setTitle("BinderMembers").setMessage(users).setPositiveButton("OK",null);
        builder.show();
    }

    public void openMessagePage(View v){
        Intent intent = new Intent();
        intent.setClass(this, MsgListFragmentActvitiy.class);
        startActivity(intent);
    }
}
